<?xml version="1.0" encoding="UTF-8"?>

<cfsSimulation xmlns="http://www.cfs++.org/simulation">
  <documentation>
    <title>multisequence test</title>
    <authors>
      <author>Daniel Huebner</author>
    </authors>
    <date>2020-01-07</date>
    <keywords>
      <keyword>output</keyword>
      <keyword>hdf5</keyword>
      <keyword>multiSequence</keyword>
      <keyword>optimization</keyword>
      <keyword>buckling</keyword>
    </keywords>
    <references></references>
    <isVerified>yes</isVerified>
    <description>
    </description>
  </documentation>
  <fileFormats>
    <output>
      <hdf5 />
    </output>
    <materialData file="./mat.xml" format="xml" />
  </fileFormats>

  <domain geometryType="plane">
    <variableList>
      <var name="E" value="10" />
      <var name="nu" value="0.3" />
    </variableList>
    <regionList>
      <region name="mech" material="elastic" />
    </regionList>
    <nodeList>
      <nodes name="top">
        <list>
          <freeCoord comp="x" start="0" inc="1" stop="100" />
          <fixedCoord comp="y" value="900"/>
        </list>
      </nodes>
      <nodes name="bottom">
        <list>
          <freeCoord comp="x" start="0" inc="1" stop="100" />
          <fixedCoord comp="y" value="0.0"/>
        </list>
      </nodes>
      <nodes name="top_left">
        <coord x="0" y="900"/>
      </nodes>
      <nodes name="top_right">
        <coord x="100" y="900"/>
      </nodes>
      <nodes name="bottom_mid">
        <coord x="50" y="0"/>
      </nodes>
    </nodeList>
  </domain>

  <sequenceStep index="1">
    <analysis>
      <static />
    </analysis>
    <pdeList>
      <mechanic subType="planeStress">
        <regionList>
          <region name="mech" thickness="4.0" />
        </regionList>
        <bcsAndLoads>
          <fix name="bottom">
            <comp dof="y"/>
          </fix>
          <fix name="bottom_mid">
            <comp dof="x"/>
          </fix>
          <force name="top">
            <comp dof="y" value="-1"/>
          </force>
          <force name="top_left">
            <comp dof="y" value="+1/202"/>
          </force>
          <force name="top_right">
            <comp dof="y" value="+1/202"/>
          </force>
        </bcsAndLoads>
        <storeResults>
          <nodeResult type="mechRhsLoad">
            <allRegions />
          </nodeResult>
          <elemResult type="mechStress">
            <allRegions />
          </elemResult>
          <nodeResult type="mechDisplacement">
            <allRegions />
          </nodeResult>
          <elemResult type="mechPseudoDensity">
            <allRegions/>
          </elemResult>
          <elemResult type="physicalPseudoDensity">
            <allRegions/>
          </elemResult>
        </storeResults>
      </mechanic>
    </pdeList>
    <linearSystems>
      <system>
        <solutionStrategy>
          <standard>
<!--             <exportLinSys stiffness="true" system="true" rhs="true" solution="true"/> -->
            <matrix/>
          </standard>
        </solutionStrategy>
      </system>
    </linearSystems>
  </sequenceStep>

  <sequenceStep index="2">
    <analysis>
      <buckling inverse="yes">
        <numModes>5</numModes>
        <valueShift>1</valueShift>
        <calcModes normalization="solver" />
      </buckling>
    </analysis>
    <pdeList>
      <mechanic subType="planeStress">
        <regionList>
          <region name="mech" thickness="4.0" />
        </regionList>
        <bcsAndLoads>
          <fix name="bottom">
            <comp dof="y"/>
          </fix>
          <fix name="bottom_mid">
            <comp dof="x"/>
          </fix>
          <referenceLoad region="mech">
            <referenceStress sequenceStep="1" />
          </referenceLoad>
        </bcsAndLoads>
        <storeResults>
          <elemResult type="mechStress">
            <allRegions />
          </elemResult>
          <nodeResult type="mechDisplacement">
            <allRegions />
          </nodeResult>
        </storeResults>
      </mechanic>
    </pdeList>
    <linearSystems>
      <system>
        <solutionStrategy>
          <standard>
<!--             <exportLinSys geometric_stiffness="true" stiffness="true" solution="true" rhs="false" auxiliary="false"/> -->
            <matrix storage="sparseSym" />
            <eigenSolver id="arpack" />
          </standard>
        </solutionStrategy>
        <eigenSolverList>
          <phist id="phist" />
          <arpack id="arpack"/>
          <feast id="feast">
            <stopCrit>4</stopCrit>
          </feast>
        </eigenSolverList>
      </system>
    </linearSystems>
  </sequenceStep>
  
  <optimization>
    <costFunction type="compliance" task="minimize" sequence="1" />
    
    <optimizer type="evaluate" maxIterations="0"/>

    <ersatzMaterial material="mechanic" method="simp" region="mech">
      <design name="density" initial="1.0" lower="1e-3" upper="1.0" />
      <transferFunction type="identity" application="mech"/>
      <export save="all" />
    </ersatzMaterial>
    <commit mode="each_forward" stride="1" />
  </optimization>

</cfsSimulation>
